#define CAESAR_ADT_EXPERT_F 4.3

/* ------------------------------------------------------------------------- */

/* forward */ CAESAR_ADT_TYPE_CFSP CAESAR_ADT_FUNC_DATAREQ();
/* forward */ CAESAR_ADT_TYPE_CFSP CAESAR_ADT_FUNC_DATAIND();
/* forward */ CAESAR_ADT_TYPE_CFSP CAESAR_ADT_FUNC_JOIN();
/* forward */ CAESAR_ADT_TYPE_CFSP CAESAR_ADT_FUNC_LEAVE();

CAESAR_ADT_TYPE_CFSP* CAESAR_ADT_GEN_ITR_CFSP( int* len )
{    static CAESAR_ADT_TYPE_CFSP* CAESAR_tmp = 0;
	 static int CAESAR_first_free = -1;
     int CAESAR_beyond = -1;
     CAESAR_ADT_TYPE_CFSP CAESAR_ADT_0;
     if (CAESAR_tmp) {
     	(*len) = CAESAR_first_free;
     	return CAESAR_tmp;
     }
     CAESAR_ADT_CALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_CFSP, CAESAR_EL_SIZE, CAESAR_ADT_TYPE_CFSP*, "CFSP [6]", "CAESAR_ADT_GEN_ITR_CFSP");
     CAESAR_first_free = 0;
     CAESAR_beyond = CAESAR_EL_SIZE;
     { /* DATAREQ */
        CAESAR_ADT_TYPE_DATAFIELD CAESAR_ADT_1;
        CAESAR_ADT_ITR_DATAFIELD (CAESAR_ADT_1) {
	     CAESAR_ADT_0 = CAESAR_ADT_FUNC_DATAREQ (CAESAR_ADT_1);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_CFSP, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_CFSP*, "DATAREQ [150]", "CAESAR_ADT_GEN_ITR_CFSP");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	    }
    }
    { /* DATAIND */
        CAESAR_ADT_TYPE_USERTITLE CAESAR_ADT_1;
        CAESAR_ADT_TYPE_DATAFIELD CAESAR_ADT_2;
        CAESAR_ADT_ITR_USERTITLE (CAESAR_ADT_1) {
         CAESAR_ADT_ITR_DATAFIELD (CAESAR_ADT_2) {
	       CAESAR_ADT_0 = CAESAR_ADT_FUNC_DATAIND (CAESAR_ADT_1,CAESAR_ADT_2);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_CFSP, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_CFSP*, "DATAIND [150]", "CAESAR_ADT_GEN_ITR_CFSP");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	     }
	    }
    }
    { /* JOIN */
        CAESAR_ADT_TYPE_USERTITLE CAESAR_ADT_1;
        CAESAR_ADT_TYPE_CONFIDENT CAESAR_ADT_2;
        CAESAR_ADT_ITR_USERTITLE (CAESAR_ADT_1) {
         CAESAR_ADT_ITR_CONFIDENT (CAESAR_ADT_2) {
	       CAESAR_ADT_0 = CAESAR_ADT_FUNC_JOIN (CAESAR_ADT_1,CAESAR_ADT_2);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_CFSP, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_CFSP*, "JOIN [150]", "CAESAR_ADT_GEN_ITR_CFSP");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	     }
	    }
    }
    { /* LEAVE */
	       CAESAR_ADT_0 = CAESAR_ADT_FUNC_LEAVE ();
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_CFSP, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_CFSP*, "LEAVE [150]", "CAESAR_ADT_GEN_ITR_CFSP");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
    }
 	if (CAESAR_first_free >= CAESAR_beyond) {
	    CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_CFSP, 1 + CAESAR_beyond, CAESAR_ADT_TYPE_CFSP*, "CFSP [6]", "CAESAR_ADT_GEN_ITR_CFSP");
	    CAESAR_beyond += 1;
	 }
#if 0
	 CAESAR_tmp[CAESAR_first_free] = 0; /* to be able to find end of array */
	 CAESAR_first_free++;
#else
	(*len) = CAESAR_first_free;
#endif
	 return CAESAR_tmp;

}

#undef CAESAR_ADT_ITR_CFSP
#define CAESAR_ADT_ITR_CFSP(CAESAR_ADT_0) \
int i = 0; \
int len; \
CAESAR_ADT_TYPE_CFSP *tmp = CAESAR_ADT_GEN_ITR_CFSP(&len); \
for ((CAESAR_ADT_0 = tmp[0]); \
     i < len; \
     (CAESAR_ADT_0 = tmp[++i]))


/* ------------------------------------------------------------------------- */
/* forward */ CAESAR_ADT_TYPE_PDU CAESAR_ADT_FUNC_PDU_J();
/* forward */ CAESAR_ADT_TYPE_PDU CAESAR_ADT_FUNC_PDU_A();
/* forward */ CAESAR_ADT_TYPE_PDU CAESAR_ADT_FUNC_PDU_L();
/* forward */ CAESAR_ADT_TYPE_PDU CAESAR_ADT_FUNC_PDU_D();

CAESAR_ADT_TYPE_PDU* CAESAR_ADT_GEN_ITR_PDU( int *len )
{    static CAESAR_ADT_TYPE_PDU* CAESAR_tmp = 0;
     static int CAESAR_first_free = -1;
     int CAESAR_beyond = -1;
     CAESAR_ADT_TYPE_PDU CAESAR_ADT_0;
     if (CAESAR_tmp) {
     	(*len) = CAESAR_first_free;
     	return CAESAR_tmp;
     }
     CAESAR_ADT_CALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_PDU, CAESAR_EL_SIZE, CAESAR_ADT_TYPE_PDU*, "UDPSP [6]", "CAESAR_ADT_GEN_ITR_UDPSP");
     CAESAR_first_free = 0;
     CAESAR_beyond = CAESAR_EL_SIZE;
     { /* PDU_J */
        CAESAR_ADT_TYPE_USERTITLE CAESAR_ADT_2;
        CAESAR_ADT_TYPE_CONFIDENT CAESAR_ADT_3;
          CAESAR_ADT_ITR_USERTITLE (CAESAR_ADT_2) {
           CAESAR_ADT_ITR_CONFIDENT (CAESAR_ADT_3) {
	        CAESAR_ADT_0 = CAESAR_ADT_FUNC_PDU_J (CAESAR_ADT_2,CAESAR_ADT_3);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_PDU, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_PDU*, "DATAREQ [150]", "CAESAR_ADT_GEN_ITR_PDU");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	       }
	      }
    }
    { /* PDU_A */
        CAESAR_ADT_TYPE_USERTITLE CAESAR_ADT_2;
        CAESAR_ADT_TYPE_CONFIDENT CAESAR_ADT_3;
          CAESAR_ADT_ITR_USERTITLE (CAESAR_ADT_2) {
           CAESAR_ADT_ITR_CONFIDENT (CAESAR_ADT_3) {
	        CAESAR_ADT_0 = CAESAR_ADT_FUNC_PDU_A (CAESAR_ADT_2,CAESAR_ADT_3);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_PDU, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_PDU*, "DATAREQ [150]", "CAESAR_ADT_GEN_ITR_PDU");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	       }
	      }
    }
    { /* PDU_L */
        CAESAR_ADT_TYPE_USERTITLE CAESAR_ADT_2;
        CAESAR_ADT_TYPE_CONFIDENT CAESAR_ADT_3;
          CAESAR_ADT_ITR_USERTITLE (CAESAR_ADT_2) {
           CAESAR_ADT_ITR_CONFIDENT (CAESAR_ADT_3) {
	        CAESAR_ADT_0 = CAESAR_ADT_FUNC_PDU_L (CAESAR_ADT_2,CAESAR_ADT_3);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_PDU, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_PDU*, "DATAREQ [150]", "CAESAR_ADT_GEN_ITR_PDU");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	       }
	      }
    }
    { /* PDU_D */
        CAESAR_ADT_TYPE_DATAFIELDLEN CAESAR_ADT_2;
        CAESAR_ADT_TYPE_DATAFIELD CAESAR_ADT_3;
          CAESAR_ADT_ITR_DATAFIELDLEN (CAESAR_ADT_2) {
           CAESAR_ADT_ITR_DATAFIELD (CAESAR_ADT_3) {
	        CAESAR_ADT_0 = CAESAR_ADT_FUNC_PDU_D (CAESAR_ADT_2,CAESAR_ADT_3);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_PDU, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_PDU*, "DATAREQ [150]", "CAESAR_ADT_GEN_ITR_PDU");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	       }
	      }
    }
 	if (CAESAR_first_free >= CAESAR_beyond) {
	    CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_PDU, 1 + CAESAR_beyond, CAESAR_ADT_TYPE_PDU*, "UDPSP [6]", "CAESAR_ADT_GEN_ITR_UDPSP");
	    CAESAR_beyond += 1;
	 }
#if 0
	 CAESAR_tmp[CAESAR_first_free] = 0; /* to be able to find end of array */
	 CAESAR_first_free++;
#else
	(*len) = CAESAR_first_free;
#endif
	 return CAESAR_tmp;

}

#undef CAESAR_ADT_ITR_PDU
#define CAESAR_ADT_ITR_PDU(CAESAR_ADT_0) \
int i = 0; \
int len; \
CAESAR_ADT_TYPE_PDU *tmp = CAESAR_ADT_GEN_ITR_PDU(&len); \
for ((CAESAR_ADT_0 = tmp[0]); \
     i < len; \
     (CAESAR_ADT_0 = tmp[++i]))


/* ------------------------------------------------------------------------- */
/* forward */ CAESAR_ADT_TYPE_UDPSP CAESAR_ADT_FUNC_UDP_DATAREQ ();
/* forward */ CAESAR_ADT_TYPE_UDPSP CAESAR_ADT_FUNC_UDP_DATAIND ();

CAESAR_ADT_TYPE_UDPSP* CAESAR_ADT_GEN_ITR_UDPSP( int *len )
{    static CAESAR_ADT_TYPE_UDPSP* CAESAR_tmp = 0;
     static int CAESAR_first_free = -1;
     int CAESAR_beyond = -1;
     CAESAR_ADT_TYPE_UDPSP CAESAR_ADT_0;
     if (CAESAR_tmp) {
     	(*len) = CAESAR_first_free;
     	return CAESAR_tmp;
     }
     CAESAR_ADT_CALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_UDPSP, CAESAR_EL_SIZE, CAESAR_ADT_TYPE_UDPSP*, "UDPSP [6]", "CAESAR_ADT_GEN_ITR_UDPSP");
     CAESAR_first_free = 0;
     CAESAR_beyond = CAESAR_EL_SIZE;
     { /* UDP_DATAREQ */
        CAESAR_ADT_TYPE_UDPADDRESS CAESAR_ADT_1;
        CAESAR_ADT_TYPE_PDU CAESAR_ADT_2;
        CAESAR_ADT_ITR_UDPADDRESS (CAESAR_ADT_1) {
	        CAESAR_ADT_ITR_PDU (CAESAR_ADT_2) {
	            CAESAR_ADT_0 = CAESAR_ADT_FUNC_UDP_DATAREQ (CAESAR_ADT_1, CAESAR_ADT_2);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_UDPSP, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_UDPSP*, "UDPSP [6]", "CAESAR_ADT_GEN_ITR_UDPSP");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	        }
	    }
    }
    { /* UDP_DATAIND */
        CAESAR_ADT_TYPE_UDPADDRESS CAESAR_ADT_1;
        CAESAR_ADT_TYPE_PDU CAESAR_ADT_2;
        CAESAR_ADT_ITR_UDPADDRESS (CAESAR_ADT_1) {
	        CAESAR_ADT_ITR_PDU (CAESAR_ADT_2) {
	            CAESAR_ADT_0 = CAESAR_ADT_FUNC_UDP_DATAIND (CAESAR_ADT_1, CAESAR_ADT_2);
	            if (CAESAR_first_free >= CAESAR_beyond) {
	                CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_UDPSP, CAESAR_EL_SIZE + CAESAR_beyond, CAESAR_ADT_TYPE_UDPSP*, "UDPSP [6]", "CAESAR_ADT_GEN_ITR_UDPSP");
	            	CAESAR_beyond += CAESAR_EL_SIZE;
	            }
	            CAESAR_tmp[CAESAR_first_free] = CAESAR_ADT_0;
	            CAESAR_first_free++;
	        }
	    }
    }
	if (CAESAR_first_free >= CAESAR_beyond) {
	    CAESAR_ADT_REALLOC (CAESAR_tmp, CAESAR_ADT_TYPE_UDPSP, 1 + CAESAR_beyond, CAESAR_ADT_TYPE_UDPSP*, "UDPSP [6]", "CAESAR_ADT_GEN_ITR_UDPSP");
	    CAESAR_beyond += 1;
	 }
#if 0
	 CAESAR_tmp[CAESAR_first_free] = 0; /* to be able to find end of array */
	 CAESAR_first_free++;
#else
	(*len) = CAESAR_first_free;
#endif
	 return CAESAR_tmp;
}

#undef CAESAR_ADT_ITR_UDPSP
#define CAESAR_ADT_ITR_UDPSP(CAESAR_ADT_0) \
int i = 0; \
int len; \
CAESAR_ADT_TYPE_UDPSP *tmp = CAESAR_ADT_GEN_ITR_UDPSP(&len); \
for ((CAESAR_ADT_0 = tmp[0]); \
     i < len; \
     (CAESAR_ADT_0 = tmp[++i]))


/* ------------------------------------------------------------------------- */
